/* Terraform - (C) 1997-2000 Robert Gasch (r.gasch@chello.nl)
 *  - http://212.187.12.197/RNG/terraform/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _TF_DIALOG_GEN_PERLIN_H
#define _TF_DIALOG_GEN_PERLIN_H 1

#include "gtk--/adjustment.h"
#include "gtk--/box.h"
#include "gtk--/checkbutton.h"
#include "gtk--/combo.h"
#include "gtk--/entry.h"
#include "gtk--/label.h"
#include "gtk--/scale.h"
#include "gtk--/separator.h"
#include "gtk--/spinbutton.h"

#include "GuiDialogOAC.h"
#include "TFWindowHandler.h"


#define FILTER_0	"None"
#define FILTER_SQ1	"Squared #1"
#define FILTER_SQ2	"Squared #2"
#define FILTER_SQ3	"Squared #3"
#define FILTER_ATAN1	"Arc Tangent #1"
#define FILTER_ATAN2	"Arc Tangent #2"
#define FILTER_ATAN3	"Arc Tangent #3"
#define FILTER_ACOS1	"Arc Cosine #1"
#define FILTER_ACOS2	"Arc Cosine #2"
#define FILTER_ACOS3	"Arc Cosine #3"
#define FILTER_COS1	"Cosine #1"
#define FILTER_COS2	"Cosine #2"
#define FILTER_EXP1	"Exponent #1"
#define FILTER_EXP2	"Exponent #2"
#define FILTER_EXP3	"Exponent #3"
#define FILTER_EXP4	"Exponent #4"
#define FILTER_EXP5	"Exponent #5"
#define FILTER_LOG1	"Logarithm #1"
#define FILTER_LOG2	"Logarithm #2"
#define FILTER_LOG3	"Logarithm #3"
#define FILTER_TANH	"Hyperbolic Tangent"
#define FILTER_SQRT	"Square Root"
#define MF		23			// maximum number of filters



/*
 *  TFDialogGenPerlin: display the d options dialog for terraformer
 */
class TFDialogGenPerlin : public GuiDialogOAC
	{
	public: 
				TFDialogGenPerlin ();
				~TFDialogGenPerlin (); 
		void		reset ();
		void		seedCheckboxCallback ();
		void		buildDialogWindow ();
		void 		buttonCallbackApply ();

	private:
		void		fillVBox ();
		void		handleCheckboxCallback (int i);
		gint 		delete_event_impl (GdkEventAny *);

		int			d_mode;
		Gtk::VBox		d_vbList1,
					d_vbList2;
		Gtk::HBox		d_hbCategories, 
					d_hbParam1, d_hbParam2, 
					d_hbParam3, d_hbParam4, 
					d_hbSize, 
					d_hbGenSeed, d_hbSeed;
		Gtk::CheckButton	d_cbGenSeed,
					d_cb1, d_cb2, d_cb3, d_cb4;
		Gtk::Entry		d_enSeed;
		Gtk::Frame		d_frmPerlin, d_frmGen;
		Gtk::HSeparator		d_sepMain, d_sepRnd;
		Gtk::Combo		*p_cmbFilter1, *p_cmbFilter2, 
					*p_cmbFilter3, *p_cmbFilter4; 
		Gtk::Label		*p_lblFreq, *p_lblAmp, 
					*p_lblIter, *p_lblFilter, 
					*p_lblSize, 
					*p_lblGenSeed, *p_lblSeed;
		Gtk::Adjustment		*p_adjSize,
					*p_adjFreq1, *p_adjFreq2, 
					*p_adjFreq3, *p_adjFreq4, 
					*p_adjAmp1, *p_adjAmp2, 
					*p_adjAmp3, *p_adjAmp4, 
					*p_adjIter1, *p_adjIter2, 
					*p_adjIter3, *p_adjIter4; 
		Gtk::HScale		*p_hsSize;
		Gtk::SpinButton		*p_spbFreq1, *p_spbFreq2, 
					*p_spbFreq3, *p_spbFreq4, 
					*p_spbAmp1, *p_spbAmp2, 
					*p_spbAmp3, *p_spbAmp4, 
					*p_spbIter1, *p_spbIter2, 
					*p_spbIter3, *p_spbIter4; 
		char			*p_seedInitStr;
		char			**p_filters;
		HeightField		*p_HF;
		TFWindowHandler		*p_tfWin;
	};


#endif // _TF_DIALOG_GEN_PERLIN_H
