/* Terraform - (C) 1997-2000 Robert Gasch (r.gasch@chello.nl)
 *  - http://212.187.12.197/RNG/terraform/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _TF_WINDOW_MAIN_H
#define _TF_WINDOW_MAIN_H 1


#include <gtk--/box.h>
#include <gtk--/fileselection.h>
#include <gtk--/menubar.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/window.h>

#include "GuiDialogOAC.h"
#include "GuiDialogYN.h"
#include "GuiDialogAbout.h"
#include "TFCListMainWin.h"
#include "TFWindowBase.h"


/*
 *  TFWindowMain: the main (drawing) window for terraformer. Extends
 * 	TFWindowBase to inherit the shared dialogs. Since TFWindowMain
 * 	doesn't inherit a Gtk-- widget, we have to let it inherit 
 * 	SigC::Object if we want to be able to connect to signals. 
 */
class TFWindowMain : public TFWindowBase, public SigC::Object
	{
	public: 
				TFWindowMain (FlexArray *wList); 
		virtual		~TFWindowMain (); 
		virtual void 	quit ();
		void		checkMenus ();
		Gtk::CList	*getCList () 	{ return p_cList; }

	protected: 
		virtual void	fileMenuCallback (string m);
		void            fileSelectionOK ();
                void            fileSelectionCancel ();
                void            fileSelection ();
		void		buildWindow ();
		void		closeCallback ();
		gint		handleDeleteEvent (GdkEventAny *e);

		Gtk::VBox		d_vBoxList,
					d_vBoxMenu,
					d_vBoxMain;
		Gtk::MenuBar		d_menuBar;
		Gtk::Window		*p_win;
		TFCListMainWin		*p_cList;
		Gtk::FileSelection	*p_fileSelection;
		Gtk::ScrolledWindow	*p_scrolledWin;
		GuiDialogOAC		*p_genSSynthDialog,
					*p_genSubdivDialog;

		// need this for menu sensitivity 
		Gtk::MenuItem		*p_miMerge;
	};


#endif // _TF_WINDOW_MAIN_H

